#ifdef openbsd
 #define ACCT_COMM 10
#endif
#ifdef netbsd
 #define ACCT_COMM 10
#endif
#ifdef freebsd
 #define AC_COMM_LEN ACCT_COMM
 #define ACCT_COMM 15
#endif

int clearAcct(const char *file,
              const char *to_file, 
		        const char *replace,
		        const char *cmd,
	  	        const char *user,
	  	        const char *tty,
		        int clear_core, 	
	  	        int verbose, 
	  	        const char *logfile,
	  	        const char *key);

/* 
 * Linux
 * struct acct
  {
    char ac_flag;                        Accounting flags.  
    u_int16_t ac_uid;                    Accounting user ID.  
    u_int16_t ac_gid;                    Accounting group ID.  
    u_int16_t ac_tty;                    Controlling tty.  
    u_int32_t ac_btime;                  Beginning time.  
    comp_t ac_utime;                     Accounting user time.  
    comp_t ac_stime;                     Accounting system time.  
    comp_t ac_etime;                     Accounting elapsed time.  
    comp_t ac_mem;                       Accounting average memory usage.  
    comp_t ac_io;                        Accounting chars transferred.  
    comp_t ac_rw;                        Accounting blocks read or written.  
    comp_t ac_minflt;                    Accounting minor pagefaults.  
    comp_t ac_majflt;                    Accounting major pagefaults.  
    comp_t ac_swaps;                     Accounting number of swaps.  
    u_int32_t ac_exitcode;               Accounting process exitcode.  
    char ac_comm[ACCT_COMM+1];           Accounting command name.  
    char ac_pad[10];                     Accounting padding bytes.  
  };

#  #define	AFORK	0001		 has executed fork, but no exec 
#  #define  ASU 0002             used super-user privileges 
#  #define	ACOMPAT	0004		 used compatibility mode 
#  #define	ACORE	0010		 dumped core 
#  #define	AXSIG	0020		 killed by a signal 
#  #define	ACCTF	0300		 record type: 00 = acct 

 *
 * OpenBSD
   typedef u_int16_t comp_t;

   struct acct {
        char      ac_comm[10];  / command name /
        comp_t    ac_utime;     / user time /
        comp_t    ac_stime;     / system time /
        comp_t    ac_etime;     / elapsed time /
        time_t    ac_btime;     / starting time /
        uid_t     ac_uid;       / user id /
        gid_t     ac_gid;       / group id /
        u_int16_t ac_mem;       / average memory usage /
        comp_t    ac_io;        / count of IO blocks /
        dev_t     ac_tty;       / controlling tty /

   #define AFORK   0x01            / fork'd but not exec'd /
   #define ASU     0x02            / used super-user permissions /
   #define ACOMPAT 0x04            / used compatibility mode /
   #define ACORE   0x08            / dumped core /
   #define AXSIG   0x10            / killed by a signal /
        u_int8_t  ac_flag;      / accounting flags /
   };
  
 *
 */

