#include <stdio.h>
#include <stdbool.h>
#include <string.h>

#include <logs_mod_sec.h>
#include <log_it.h>

/*
 * It is more or less "grep -v string file >to_file"
  *  
 *  Return:
 *  On sucess: 	number of lines that are removed now
 *  Error:
 *  	-1	No file string
 *  	-2	No target file string
 *  	-3	No string to search
 *  	-4	Cannot open file
 *  	-5	Cannot open target file
 *  	-6	Cannot open logfile
 */

int remove_logs_prelude_logs(const char *file,
                const char *to_file,
		          const char *string,
		          int verbose, 
                const char *logfile, 
                const char *key)
{
   FILE *f_read, *f_write, *f_log;
   char buffer1[BUFFER + 1] = { '\0' };
   char CheckBuffer[BUFFER_FOR_LINES][BUFFER];
   char sep[]="********************************************************************************\n";
   char empty[]="\n";
   char *get_time, *grep;
   int lines_removed = 0;
   int lines_written = 0;
   int lines_org = 0;
   bool found = false;
   bool log_start = false, log_end = false;
   int a = 0,  i = 0, j = 0;
   
   /* Idiot checking (newer trust programmers!) */
   if(!file) {
	   fprintf(stderr, "[ERROR] No file to clean!\n");
	   return -1;
   }
   if(!to_file) {
	   fprintf(stderr, "[ERROR] No file to write to!\n");
	   return -2;
   }
   if(!string) {
	   fprintf(stderr, "[ERROR] No string for cleaning!\n");
	   return -3;
   }

   /* give status message */
   if(verbose > 2) {
	   printf("[STATUS]	grep -v %s in %s\n", string, file);
   }
   
   /* Open all files */
   if((f_read = fopen(file, "r")) == 0) {
	   fprintf(stderr, "[ERROR] in read opening %s\n", file);
	   perror("[ERROR] replace_in_file(): ");
	   return -4;
   }
   if((f_write = fopen(to_file, "w")) == 0) {
	   fprintf(stderr, "[ERROR] in write opening %s\n", to_file);
	   perror("[ERROR] replace_in_file(): ");
	   return -5;
   }
   if(logfile) {
	   if((f_log = fopen(logfile, "w")) == 0) {
	      fprintf(stderr, "[ERROR] in write opening %s\n", logfile);
	      perror("[ERROR] replace_in_file(): ");
	      return -6;
	   }
   }
   
   /*  clear the buffer again */
   for(j = 0; j < BUFFER_FOR_LINES; j++) {
	   memset(CheckBuffer[j], 0, BUFFER);
   }
   
   /* Ok let's start */
   while (!feof(f_read)) {	/* reading file */
	   /* reset */
	   memset(buffer1, 0, BUFFER);
	   fgets(buffer1, BUFFER, f_read);
	   lines_org++;
	   get_time = 0;
	   grep = 0;
	   a = 0;
	   
      /* this is not a logentry, so ignore it */
	   if(strlen(buffer1) < 1) {
	      break;
	   }
	   /*
       * matches ********************************************************************************
       */
      if ((strcmp(buffer1,sep) ==0) && (log_end == true)){
         log_start = true;
         log_end = false;
      } 
      if ((strcmp(buffer1,empty) ==0) && (strcmp(CheckBuffer[i-1],sep) ==0)){
         log_start = false;
         log_end = true;
      } 

      if (log_end == true){
         /*  new log */
         if(i < BUFFER_FOR_LINES) {
            memcpy(CheckBuffer[i], buffer1, BUFFER); 
            CheckBuffer[i][BUFFER - 1] = 0x0;       
	         i++;
	      } else {
            if(verbose >2) {
               fprintf(stderr, "[ERROR] \ttoo many lines\t Ignore!\n");
	         }
	         if(verbose >5) {
               for(j= 0; j <= i; j++) {
                  printf("[ERROR] Ignoring\t %s", CheckBuffer[j]);
			      }
	         }
	      }

         
         if(found == true) {	/* it matches string */
		      if(verbose > 2) {
		         printf("[INFO] Removing %d Lines\n", i);
		      }
		      if(verbose > 4) {
		         for(j = 0; j <= i; j++) {
			         printf("[FOUND]\t %s", CheckBuffer[j]);
		         }
		      }
		      if(logfile) {
		         for(j = 0; j <= i; j++) {
			         if(key) {
			            crypt_log_it(logfile, key, "[FOUND]\t %s",
					      CheckBuffer[j]);
			         } else {
			            log_it(logfile, "[FOUND]\t %s",
				         CheckBuffer[j]);
			         }
		         }
		      }
		      found = false;
	         } else {	/* entry is clean, so it can be written to file */
		            for(j = 0; j <= i; j++) {
		               fprintf(f_write, "%s", CheckBuffer[j]);
		            }
                  lines_written = lines_written + i ;
                 
                  
            }
            /* clear the buffer again */
	         for(j = 0; j <= i; j++) {
		         memset(CheckBuffer[j], 0, BUFFER);
	         }
            /* reset counter */
	         i = 0;
            

      } else{ /* same log*/
         /* save in buffer */
                 if(i < BUFFER_FOR_LINES) {
            memcpy(CheckBuffer[i], buffer1, BUFFER); 
            CheckBuffer[i][BUFFER - 1] = 0x0;       
	         i++;
	      } else {
            if(verbose >2) {
               fprintf(stderr, "[ERROR] \ttoo many lines\t Ignore!\n");
	         }
	         if(verbose >5) {
               for(j= 0; j <= i; j++) {
                  printf("[ERROR] Ignoring\t %s", CheckBuffer[j]);
			      }
	         }
	      }
         
         /* grep for string */
	      grep = strstr(buffer1, string);
	      if(grep != 0) {	/* found */
	         found = true;
	      }

      }
      


         
     }	/* end reading file */

   /* don't forget the rest */
   if(found == false) {	/* rest is clean, so write it to file */
	   for(j = 0; j <= i; j++) {
	      fprintf(f_write, "%s", CheckBuffer[j]);
	      lines_written++;
	   }
      if(i>1){
         fprintf(f_write, "%s", buffer1);
         lines_written++;
      }

	   
      /*lines_written++; */
   } else {			/* it matches string */
	   if(verbose > 3) {
	      printf("[INFO] Removing %d Lines\n", i);
	   }
	   if(verbose > 4) {
	      for(j = 0; j <= i; j++) {
		      printf("[FOUND]\t %s", CheckBuffer[j]);
	      }
	   }
	   if(logfile) {
	      for(j = 0; j <= i; j++) {
		      if(key) {
		         crypt_log_it(logfile, key, "[FOUND]\t %s",
				   CheckBuffer[j]);
		      } else {
		         log_it(logfile, "[FOUND]\t %s", CheckBuffer[j]);
		      }
	      }
	   }
   }

   /* Closing files again */
   /* no, there some bug at the moment, later...*/
   /* if (f_log != 0) {
	 *    fclose(f_log);
    * } 
    */
    fclose(f_write);
    fclose(f_read);

    /* calculate statistic */
    lines_org--;
    lines_written--;

    lines_removed = lines_org - lines_written;
      
    if(verbose > 2) {
       printf("[STATUS] From %d lines %d lines written -> %d lines removed\n",
              lines_org, lines_written, lines_removed);
    }
    
    return(lines_removed);
}
